
package org.apidesign.apifest08.currency;

public final class ConvertorFactory {

    //Singleton
    private static ConvertorFactory thisFactory = new ConvertorFactory();    
    private ConvertorFactory() {};    
    public static ConvertorFactory newInstance() {
        return thisFactory;
    }        
    
    public Convertor createConvertor(String currency1, String currency2, Rate rate) {
        return new Convertor(currency1, currency2, rate);
    }
    
    public Convertor createConvertor(String currency1, String currency2, int amount1, int amount2) {
        return new Convertor(currency1, currency2, new Rate(amount1, amount2));
    }

    public Convertor createConvertor(String currency1, String currency2, double amount1, double amount2) {
        return new Convertor(currency1, currency2, new Rate(amount1, amount2));
    }
    
    public Convertor createConvertor(String currency1, String currency2, double rate) {
        return new Convertor(currency1, currency2, new Rate(rate));
    }
}
